﻿///////////////////////////////////////////////////////////////////////////////////////////////////
//
// GLOBAL GADGET MEMBERS
//
///////////////////////////////////////////////////////////////////////////////////////////////////
var	gProgressStep =	0;							// global var for progress animation

var gadgetVersion = 1.1;						// use for version checking

var gUsername, gPassword;						// global username and password

//check	the	latest version of the widget, if true, supported
var	bSupportedVersion =	true;					// check if	this version gadget	is supported
var	bNewVersion	= false;						// check if	there is new version gadget
var	gStrNewVersionURL =	"";						// the URL of the new versoin gadget

var iTestCount = 0;								// save the previous test count

var gStrSC3ID = "";								// session id for login 

var CONSTANTS = 
{
    abbreviated_months: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
};

var strBaseURL = "https://www.webperformnetworks.com/ui"; 	// URL for auth
var strURLReg = strBaseURL+"/widget.php?mod=register";		// URL for register

var xmldoc = "";								// store the repsonse doc in xml format

var timerRefresh = null;						// timer for refreshing data

var bInit = true;								// check if it is initial progress
var bAuthWithID = false;						// check if login with session id
var bLogin = false;								// check if the last login is valid
var gTimerProgress = null;						// timer for refreshing animation	
	
var xmlhttp, requestSignup;						// XMLHTTPRequest Object
	
// set option event
plugin.onShowOptionsDlg = showOptions;

///////////////////////////////////////////////////////////////////////////////////////////////////


/*
 * start up
 */
function view_onOpen() 	
{
	// ************** INIT *****************
	// init	global vars
	gProgressStep =	0;
	
	// get username and password from option window
	gUsername = options("email");
	gPassword = options("password");	
	
	// check if www.webperformnetworks.com is working and then choose one site(webperform.com or webperformnetworks.com to auth)
	check_signup_url();
}

//check if the signup url is existed
function check_signup_url()
{
	try
	{
		requestSignup = new XMLHttpRequest();
		requestSignup.open("GET", strBaseURL+"/widget.php", true);
		
	    //start animation
        ui_start_progress();
	        
	   	//show logout message
	   	showMessage("Checking system, please wait...");
	   	 	
		requestSignup.onreadystatechange = check_signup_done;	
		requestSignup.setRequestHeader("If-Modified-Since", "0");	
		requestSignup.setRequestHeader("Cache-Control", "no-cache");
		requestSignup.setRequestHeader("Pragma", "no-cache");
		requestSignup.send();
	}
	catch(e)
	{
		showError("Checking system failed. Cannot get test data.", true);
		ui_stop_progress();
		return;
	}
}

// check signup URL done, show login window or do auth
function check_signup_done()
{
	if(requestSignup.readyState < 4)
	{
		return;
	}

	if( requestSignup.status != "406")
	{
		strBaseURL = "http://www.webperform.com/ui";
		strURLReg = strBaseURL + "/widget.php?mod=register";
	}
	
	ui_stop_progress();
	
	//Automatically login
	if (typeof gUsername != "undefined" && gUsername != "" && gUsername != null)
	{
	    doAuth();
	}
	else
	{
	    showLogin();
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
//
// doSignup - open register window in browser
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function doSignup()
{
	openURL(strURLReg);
}

///////////////////////////////////////////////////////////////////////////////////////////////////
//
// doLoginAuth - do authentication when click the submit button in login window
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function doLoginAuth()
{
	/*
	// for testing //
	gUsername = "guest";
	gPassword = "guest";
	doAuth();
	return;
	*/
	if(oUsername.value == "" || oUsername.value == null || oUsername.value == "undefined")
	{
		showError("Please provide your login info. Click here to set.", "showLogin()");																		
		return;	
	}

	if(gUsername != oUsername.value || gPassword != oPassword.value)
	{
		gUsername = options("email") = oUsername.value;
		gPassword = options("password") = oPassword.value;
		
		//logout the old userAgent
		doLogout();
		//set session id to null
		gStrSC3ID = "";
		doAuth();
	}
	else if (bLogin)
		showDataWindow();	
	else
		showError("Please provide your valid login info. Click here to set.", "showLogin()");																																																
}

/*
 * add an option window
 */
function showOptions(window) 
{
    window.AddControl(gddWndCtrlClassLabel, 0, "", "Enter your webperform login info:",    10, 10, 190, 20);
    window.AddControl(gddWndCtrlClassLabel, 0, "", "Username: ",    10, 37, 150, 20);
    var eu = window.AddControl(gddWndCtrlClassEdit, 0, "emailBox", "", 80, 35, 150, 23);
    window.AddControl(gddWndCtrlClassLabel, 0, "", "Password: ", 10, 67, 150, 20); 
    var ep = window.AddControl(gddWndCtrlClassEdit, gddWndCtrlTypeEditPassword, "passwordBox", "", 80, 65, 150, 20); 
    // set email and password
    eu.value = options("email");
    ep.value = options("password");
    
    // set close event
    window.onClose = OnOptionsClose;

	// close event function
    function OnOptionsClose(window, code) 
	{
        if (code == gddIdOK) 
		{
            var ok = false;
            var strEmail = window.GetControl("emailBox").value;
            var strPassword = window.GetControl("passwordBox").value;
			
			if(gUsername != strEmail || gPassword != strPassword)
			{
				// save email and password
            	gUsername = options("email") = strEmail;
           		gPassword = options("password") = strPassword;
           		
           		s//logout the old userAgent
				doLogout();
           		gStrSC3ID = "";
				//gadget.debug.trace(strEmail+" "+strPassword);
				doAuth();
			}
        }        
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////////
//
// showMessage - show message in the message window, i.e. we must change the background
//				 para: strMessage -> the message will be showed
//					   pClickAction	-> the click action	event
//					   bError	-> if the message is for error info
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function showMessage(strMessage, pClickAction, bError)
{
	oMessageWindow.visible="true";
	oLoginWindow.visible="false";
	oTestdataWindow.visible="false";
	
	// show message text
	oMessage.innerText = strMessage;
	
	// set view height
	view.height = 153;
	//debug.trace("Message: " + view.height);
	
	// set initial property
	oMessage.color = bError=="true" ? "#FF0000" : "#778877";
	oMessage.onmousemove = "";
	oMessage.onmouseout = "";
	oMessage.onclick = "";
	oMessage.cursor = "arrow";
				
	// check if	the	message	length is too long
	if(strMessage.length > 30)
	{
		oMessage.height = 30;
		oMessage.wordWrap = "true";
		oMessage.y = "0";
	}
	else
	{
		oMessage.height = 15;
		oMessage.wordWrap = "false";
		oMessage.y = "9";
	}
	
	// set click action
	if(strMessage != "") 
	{
		if(pClickAction	== null) pClickAction =	"";
			
		if(pClickAction	!= "") 
		{
			var oldColor = oMessage.color;
			oMessage.onmousemove = "oMessage.color='#0000FF'";
			oMessage.onmouseout = "oMessage.color='"+oldColor+"'";
			oMessage.onclick = pClickAction;
			oMessage.cursor = "hand";
		} 
	}
	
	/*
	oMessageDiv.appendElement("<label name='oMessageRetry' underline='true' color='#003366' cursor='hand' "
		+"enabled='true' y='17' font='Arial' size='8' "+
        	"onclick='"+pClickAction+"'" + " onmouseout=\"oMessageCancel.color='#003366';\" " + 
        	"onmouseover=\"oMessageRetry.color='#0000FF';\">Retry</label>");	
   	*/  
}

///////////////////////////////////////////////////////////////////////////////////////////////////
//
// showError - show	error message in the message window, i.e. we must change the background
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function showError(strMessage, pClickAction) 
{
	showMessage(strMessage,	pClickAction, "true");
}

///////////////////////////////////////////////////////////////////////////////////////////////////
//
// showLogin - show login window 
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function showLogin()
{
	//debug.trace("click login");
	oMessageWindow.visible="false";
	oLoginWindow.visible="true";
	oTestdataWindow.visible="false";
	
	oUsername.focus();
	oCancelButton.visible="true";
	oUsername.value = options("email");
	oPassword.value = options("password");
	
	// set view height
	view.height = 190;
	
	// set cancel button state
	oCancelButton.visible = bLogin;
	//debug.trace("Login: " + view.height);
}

///////////////////////////////////////////////////////////////////////////////////////////////////
//
// showDataWindow - show test data window 
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function showDataWindow()
{
	oMessageWindow.visible = "false";	
	oLoginWindow.visible = "false";
	oTestdataWindow.visible = "true";
	
	// set view height
	// set view's height
	view.height = oTop.srcHeight + iTestCount*16 + 57;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
//
// openURL - open URL in a browser 
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function openURL(url)
{ 
  var wshShell = new ActiveXObject("WScript.Shell"); 
  wshShell.run(url); 
  wshShell = null; 
} 

///////////////////////////////////////////////////////////////////////////////////////////////////
//
// ui_progress_step	- start	animation progress,	i.e. we	must change	the	images with	certain	interval
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function ui_progress_step( )
{	// start animation progress	steps
	
	// change the background of	the	main window
	gProgressStep ++;
	if(gProgressStep >9)
		gProgressStep =	0;
			
	if(oProgress !=	null)		
	{
		oProgress.src =	"images/prog_" + gProgressStep + ".png";
	}
	else
	{
		oProgress.visible = "false";
		showMessage("Starting progress failed.");
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
//
// ui_start_progress - start animation progress, i.e. we must change the images	with certain interval
//					  before calling this function, make sure the Object oProgress is existed
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function ui_start_progress(	)
{	// start animation progress
	
	gTimerProgress = setInterval(ui_progress_step, 150);		
	if(oProgress !=	null)
		oProgress.visible = "true";
}

///////////////////////////////////////////////////////////////////////////////////////////////////
//
// ui_stop_progress	- start	animation progress,	i.e. we	must change	the	images with	certain	interval
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function ui_stop_progress( )
{	// stop	animation progress
	clearInterval(gTimerProgress); 
	oProgress.visible = "false";
}

///////////////////////////////////////////////////////////////////////////////////////////////////
//
// doAuth -	do authentication procedure
//					para: bRefresh -> flag for refreshing data or not
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function doAuth(bRefresh)
{	// authentication
	try
	{
		if(bRefresh	!= true)																																																
			bRefresh = false;
			
		// clear interval 
		if(timerRefresh != null)
			clearTimeout(timerRefresh);

		if(gUsername ==	"" || gUsername == "undefined" || gUsername == null)																																																
		{																																																
			showError("Please provide your login info. Click here to set.", "showLogin()");																																																
			return;																																																
		}																																																
															
		if(bRefresh)																																																
			showMessage("Updating data, please wait...");																																																
		else																																																
			showMessage("Authenticating, please	wait...");																																																
		
		// start animation																																																
		ui_start_progress();																																																
																																																		
		// check if	the	username and the password is valid per XMLHttpRequest																																																																									tpRequest
		xmlhttp = new XMLHttpRequest();
		
		if(xmlhttp)
			debug.trace("XMLHTTP ok");
		else
			debug.trace("XMLHTTP failed");
																																															
		// authentication with session ID firstly if the id is not null
		if(gStrSC3ID.length > 1)
		{
			xmlhttp.open("GET",	strBaseURL+"/widget.php?mod=google&SC3ID="+gStrSC3ID, true);

			// set flag
			bAuthWithID = true;
			
			//debug.trace("id:"+gStrSC3ID);
		}
		else
		{
			var strAuthURL = strBaseURL+"/widget.php?mod=google&username="+escape(gUsername)+"&passwd="+escape(gPassword); 
			//debug.trace(strAuthURL);
			xmlhttp.open("GET",	strAuthURL, true);

			// set flag
			bAuthWithID = false;
			//debug.trace("username:"+gStrSC3ID);
		}	
		 
		xmlhttp.setRequestHeader("If-Modified-Since", "0");	
		xmlhttp.setRequestHeader("Cache-Control", "no-cache");
		xmlhttp.setRequestHeader("Pragma", "no-cache");  
		xmlhttp.onreadystatechange = authDone;	
		xmlhttp.send();																																															
	}
	catch(e)
	{
		showError("Cannot get data. Click here to retry."); 
        //stop animation
        ui_stop_progress();		
	}  
}


///////////////////////////////////////////////////////////////////////////////////////////////////
//
// authDone - do something when the authentication is done
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function authDone()
{	// authentication done
	// You need	to check whether the object	is ready because
	// this	function gets called also on open, send	and	receive
	debug.trace(xmlhttp.readyState);
	if(xmlhttp.readyState <	4)
	{
		return;
	}
	
	// stop	animation
	ui_stop_progress();
	
	// HTTP	200	OK (we have	data)		
	if(xmlhttp.status == 200)		
	{ 
		// check if	there is new versoin gadget
		check_version(xmlhttp.responseXML);	
	
		if(bNewVersion)
		{
			if(bSupportedVersion)
			{
				if(!bInit)
				{
					showTestData();
					return;
				}
				
				showError("New version is available.");
				
				var downloadNow = view.confirm("New version is available. \nDownload new version gadget now?");
				
				if(downloadNow)
				{
					openURL(gStrNewVersionURL);
				}
				
				showTestData();
			}			
			else		
				showError("Click here to download new version.", "openURL('"+gStrNewVersionURL+"')");
		}
		else
			showTestData();	
			
		// set login flag
		bLogin = true;
	}
	// if faild authenticatication, i.e. status is 406
	else if(xmlhttp.status == 406)
	{
		// check if Authenticating with SC3ID(session id)
		if(bAuthWithID)
		{
			// set gStrSC3ID to null
			gStrSC3ID = "";
			// authentication using username and password
			doAuth();
		}
		else
		{
			// set login flag
			bLogin = false;
			
			showError("Login failed. Click here to set valid login info.", "showLogin()");
		}	
	}
	else        
	{
		// set login flag
		bLogin = false;
		
		showError("Cannot connect to the website. Click here to retry.", "doAuth()");   
	}   
	
	// set timer for refreshing data
	timerRefresh = setTimeout("doAuth(true)", 300000);  
	
	// set init flag
	bInit = false;
	
	//stop animation
	ui_stop_progress();
}

//logout
function doLogout()
{
	var request = new XMLHttpRequest();
	request.open( "GET", strBaseURL+"/widget.php?logout=y&SC3ID=" + gStrSC3ID, true );
	request.send();
}

///////////////////////////////////////////////////////////////////////////////////////////////////
//
// showTestData	- get the tests data and then show them in the main window
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function showTestData()
{
	// get XML result
	xmldoc = xmlhttp.responseXML;
	
	// get test count
	try
	{
		iTestCount = parseInt(xmldoc.getElementsByTagName("widget").item(0).getAttribute("testcount"));
	}
	catch(e)
	{
		iTestCount = 0;
	}
	
	// check if the test count is zero
	if(iTestCount < 1)
	{
		showError("No test data found in your account.");
		return;
	}
		
	// get test information
	// get session id (only when Authenticating with username and password)
	if(!bAuthWithID)
	{	
		try
		{
			gStrSC3ID = xmldoc.getElementsByTagName("widget/sid").item(0).getAttribute("value");
		}
		catch(e)
		{
			gStrSC3ID = "";
		}	
	}
	
	// remove all elements of the test data body	
	oTestBody.removeAllElements();
	oTestBody.height = 16*iTestCount;
	showDataWindow();
		
	for(i = 0; i < iTestCount; i++)
	{		
		// add each test data to the oTestDataBody object
		addTest2Display(i, xmldoc);
   	}

	// set bottom's height
	oBottom.y = oTop.srcHeight+iTestCount*16;
		
	// get the Date
	theDate = new Date();
    theDay = String(theDate.getDate());
    theMonth = theDate.getMonth();
    theYear = String(theDate.getFullYear());
	theHour = String(theDate.getHours());
	theMinutes = String(theDate.getMinutes());
	
	if (theDay.length < 2)
	    theDay = "0" + String(theDay);	
	if (theMinutes.length < 2)
	    theMinutes = "0" + String(theMinutes);
    if (theHour.length < 2)
        theHour = "0" + String(theHour);
    
    // show the updated timeDate
   	oUpdateLabel.innerText = "Updated " + theDay + " " + CONSTANTS.abbreviated_months[theMonth] + " " 
    		+ theYear + " " + theHour + ":" + theMinutes;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
//
// addTest2Display - add a test to the display window
//					para: iIndex -> the i-th of the test
//						  strResponse -> the XML result
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function addTest2Display(iIndex, strResponse)
{
	// add element to oTestBody div
	oTestBody.appendElement("<div name='test" + iIndex + "' height='16' width='100%' " +
		"background='"+ (iIndex%2==0?"images/testname_bkgd.png":"images/testname_bkgd_gray.png") 
		+ "' y='" + 16*iIndex + "'>" +
		"<label name='name" + iIndex + "' height='15' width='65' x='9' y='1' font='Arial' size='8'></label>"+
		"<img name='img" + iIndex + "' y='2' x='88' enabled='true' cursor='hand'/>" +
		"<label name='load" + iIndex + "' height='15' tooltip='average load time(in seconds)' width='29'"+
	    	" x='108' y='1' size='8' align='right'></label>" +
		"<label name='reach" + iIndex + "' height='15' tooltip='reachability(in percentage)' width='38'" +
	              " x='140' y='1' size='8' align='right'></label></div>");

	// get test elements
	var oParentElement = oTestBody.children("test"+iIndex);
	var txtTest = oParentElement.children("name"+iIndex);
	var alertImg = oParentElement.children("img"+iIndex);
	var txtLoadTime = oParentElement.children("load"+iIndex);
	var txtReach = oParentElement.children("reach"+iIndex);
	
	// get URL since the URL is not fixed
	var tmpBaseURL;
	try
	{
    	tmpBaseURL = strResponse.getElementsByTagName("widget").item(0).getAttribute("ui");
	}
	catch(e)
	{
		tmpBaseURL = strBaseURL;
	}

	if(tmpBaseURL.charAt(tmpBaseURL.length-1) == '/')
		tmpBaseURL = tmpBaseURL.substring(0, tmpBaseURL.length-1);
    
    // get test state
    var testState;
    try
    {
    	testState = strResponse.getElementsByTagName("widget/test").item(iIndex).getAttribute("state");
    }
    catch(e)
	{
    	testState = "NODATA";
    }
     
    // get test name
    var testName;
	try
    {
    	testName = strResponse.getElementsByTagName("widget/test").item(iIndex).getAttribute("name");
    }
    catch(e)
	{
    	testName = "N/A";
    }
  
  	// get alarm state
    var testAlarmState; 
	try
    {
    	testAlarmState = strResponse.getElementsByTagName("widget/test/alarm").item(iIndex).getAttribute("color");
    }
    catch(e)
	{
    	testAlarmState = "0";
    }
 
 	// get test loadtime state
    var testLoadTimeState;
	try
    {
    	testLoadTimeState = strResponse.getElementsByTagName("widget/test/loadavg").item(iIndex).getAttribute("color");
    }
    catch(e)
	{
		testLoadTimeState = "0";  
        testState = "NODATA";
    }

	// get test loadtime link
    var testLoadTimeLink;
	try
    {
    	testLoadTimeLink = strResponse.getElementsByTagName("widget/test/loadavg").item(iIndex).getAttribute("link");
    }
    catch(e)
	{
        testLoadTimeLink = "";
        testState = "NODATA";
    }    
   
   	// get test reachability_color
    var testReachState; 
	try
    {
    	testReachState = strResponse.getElementsByTagName("widget/test/reachable").item(iIndex).getAttribute("color");
    }
    catch(e)
	{
        testReachState = "0";
        testState = "NODATA";
    }   
     
   	// get test reachability link    
    var testReachLink;
	try
    {
    	testReachLink = strResponse.getElementsByTagName("widget/test/reachable").item(iIndex).getAttribute("link");
    }
    catch(e)
	{
		testReachLink = "";
    }    
    
    // show alert state
    if(testAlarmState == "0")
    {
    	alertImg.src = "images/alarm/alarm_bkgd_gray.png";
    	alertImg.tooltip = "no alarm condition";
    }
    else if(testAlarmState == "1")
    {
        alertImg.src = "images/alarm/alarm_bkgd_blue.png";
        alertImg.tooltip = "disible alarm condition";
    }
    else if(testAlarmState == "2")
    { 
   		alertImg.src = "images/alarm/alarm_bkgd_green.png";
        alertImg.tooltip = "no alarm";
    }
    else if(testAlarmState == "3")
    {
    	alertImg.src = "images/alarm/alarm_bkgd_yellow.png";
        alertImg.tooltip = "alarm; but threshold probe portion not reached yet";
    }
    else if(testAlarmState == "4")
    {
        alertImg.src = "images/alarm/alarm_bkgd_orange.png";
        alertImg.tooltip = "alarm; but no escalation level was configured";
    }
    else if(testAlarmState == "5")
    {
        alertImg.src = "images/alarm/alarm_bkgd_red.png";
        alertImg.tooltip = "alarm; on the first escalation level";
    }
    else if(testAlarmState == "6")
    {
        alertImg.src = "images/alarm/alarm_bkgd_purple.png";
        alertImg.tooltip = "alarm; on the highest escalation level";    	
    }

    if(tmpBaseURL.length < 15)
        tmpBaseURL = strBaseURL;
    
    // get the Quickview URL with SC3ID or username/password
    var strQuickViewLink;
    if(gStrSC3ID == "")
        strQuickViewLink = tmpBaseURL + "/?mod=start&username=" + escape(gUsername) + "&passwd=" + escape(gPassword);
    else
        strQuickViewLink = tmpBaseURL + "/?mod=start&SC3ID=" + gStrSC3ID;        
    alertImg.onclick = "openURL('"+strQuickViewLink+"');"

 	// set text of loadtime
	txtTest.innerText = testName.length < 10 ? testName : testName.substring(0, 8)+"...";
	    
   	//check test state
    var testLoadtime, testReach;
    if(testState == "INAKTIV")
    {
        txtTest.color = '#9B9B9B';
        txtTest.tooltip = testName + ": inactive";
        alertImg.src = 'images/alarm/alarm_bkgd_gray.png';
        alertImg.tooltip = 'no alarm condition';
        testLoadtime = testReach = "N/A";
    }
    else if(testState == "NODATA")
    {
    	txtTest.color = '#9B9B9B';
        txtTest.tooltip = testName + ": no data";
        alertImg.src = 'images/alarm/alarm_bkgd_gray.png';
        alertImg.tooltip = 'alarm state: no data';
        testLoadtime = testReach = "N/A";
    }
    else
    {
    	txtTest.color = '#000000';
    	txtTest.tooltip = testName;
		
		try
		{
			// get loadtime value and reachability value
        	testLoadtime = strResponse.getElementsByTagName("widget/test/loadavg").item(iIndex).getAttribute("value");
        	testReach = strResponse.getElementsByTagName("widget/test/reachable").item(iIndex).getAttribute("value");
    	}
    	catch(e)
    	{
    		testLoadtime = testReach = 'N/A';
    	}
    }
    
 	// set text of loadtime
	txtLoadTime.innerText = testLoadtime;
	
 	// check loadtime state
	//color
    if(testLoadTimeState == "2") 
        txtLoadTime.color = '#089508'; 
    else if(testLoadTimeState == "3") 
        txtLoadTime.color = '#E6D931'; 
    else if(testLoadTimeState.length > 0)
        txtLoadTime.color = '#cc0000';
    else
        txtLoadTime.color = '#000000'; 
        
    // check loadtime link    
    if(testLoadTimeLink.length > 1)
    {
   		txtLoadTime.enabled = 'true';
    	txtLoadTime.underline = 'true';
    	txtLoadTime.cursor = 'hand'; 
    	
    	if(gStrSC3ID == "")
    	{        
    		txtLoadTime.onclick="openURL('"+ tmpBaseURL + "/" + testLoadTimeLink
    			+ "&username=" + escape(gUsername) + "&passwd=" + escape(gPassword) + "')";

    	}
        else
        {
    		txtLoadTime.onclick="openURL('"+ tmpBaseURL + "/" + testLoadTimeLink
    			+ "&SC3ID=" + gStrSC3ID + "')";
    	}		
	}
	else
	{
		txtLoadTime.onclick = "";
    	txtLoadTime.cursor = 'arrow'; 
    	txtLoadTime.underline = 'false';
    	txtLoadTime.enabled = 'false';
    }
	
	// set text of reachability
	txtReach.innerText = testReach;
	
	// check reachability state
    //color
    if(testReachState == "2") 
        txtReach.color = '#089508'; 
    else if(testReachState == "3") 
        txtReach.color = 'E6D931';
    else if(testReachState.length > 0)
        txtReach.color = '#cc0000';        
    else
        txtReach.color = '#000000';
        
    // check reachability link    
    if(testReachLink.length > 1)
    {
   		txtReach.enabled = 'true';
    	txtReach.underline = 'true';
    	txtReach.cursor = 'hand'; 
    	
    	if(gStrSC3ID == "")
    	{        
    		txtReach.onclick="openURL('"+ tmpBaseURL + "/" + testLoadTimeLink
    			+ "&username=" + gUsername + "&passwd=" + gPassword + "')";

    	}
        else
        {
    		txtReach.onclick="openURL('"+ tmpBaseURL + "/" + testLoadTimeLink
    			+ "&SC3ID=" + gStrSC3ID + "')";
    	}		
	}
	else
	{
		txtReach.onclick = "";
    	txtReach.cursor = 'arrow'; 
    	txtReach.underline = 'false';
    	txtReach.enabled = 'false';
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////////
//
// check_version - check the version if	there is new versoin available or needed
//					para: strResponse -> string of the xmlhttp response text
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function check_version(strResponse)
{
	// get latest version and supported	version	per	XMLDOC
	var iNowVersion, iSupportedVersion;
	try
	{
		iNowVersion	= parseFloat(strResponse.getElementsByTagName("widget").item(0).getAttribute("version"));
		iSupportedVersion =	parseFloat(strResponse.getElementsByTagName("widget").item(0).getAttribute("compatible"));
	}
	catch(e)
	{
		iNowVersion = 1.0;
		iSupportedVersion = 1.0;
	}
			
	if(!isNaN(iSupportedVersion)) 
	{
		bSupportedVersion =	iSupportedVersion <= gadgetVersion;
	}
		
	if(!isNaN(iNowVersion) && !isNaN(iSupportedVersion))
		bNewVersion	= parseFloat(gadgetVersion) < iNowVersion;
	
	// get URL of the new version gadget
	if(bNewVersion)
	{
		try
		{
			gStrNewVersionURL =	strResponse.getElementsByTagName("widget").item(0).getAttribute("nvurl");
		}
		catch(e)
		{
			gStrNewVersionURL =	"";
		}
	}
}	